
module top (
	
	input		CLK12M,      	//    		clk_in.clk
	output 	[7:0] LED,  	//   			pio_led.export
	input		USER_BTN,	 	//  			pio_mode.export
	output	SDRAM_CLK,
	output	[11:0] A,    	//     		sdram.addr
	output	[1:0] BA,      //          .ba
	output	CAS,     		//          .cas_n
	output	CKE,       		//          .cke
	output	CS,      		//          .cs_n
	inout		[15:0] DQ,     //          .dq
	output	[1:0] DQM,     //          .dqm
	output	RAS,     		//          .ras_n
	output	WE,      		//          .we_n
	inout		F_DI,  			//	 			spi_flash.MISO
	inout		F_DO,  			//          .MOSI
	output	F_CLK,  			//          .SCLK
	output	F_CS,  			//          .SS_n
	input		SEN_SDI,  		// 			spi_g_sen.MISO
	input		SEN_SDO,  		//          .MOSI
	output	SEN_SPC,  		//          .SCLK
	output	SEN_CS,  		//          .SS_n
	input		BDBUS0,         //          .txd
	output	BDBUS1        //      		uart.rxd	
);

    niosMemM10 u0 (
        .clk12m_clk      (CLK12M),      	//    		clk12m.clk
        .pio_led_export  (LED[3:0]),  		//   			pio_led.export
        .pio_mode_export (USER_BTN),	 	//  			pio_mode.export
        .sdram_addr      (A[11:0]),      	//     		sdram.addr
        .sdram_ba        (BA[1:0]),       //          .ba
        .sdram_cas_n     (CAS),     		//          .cas_n
        .sdram_cke       (CKE),       		//          .cke
		  .sdram_clk_clk	 (SDRAM_CLK),
        .sdram_cs_n      (CS),      		//          .cs_n
        .sdram_dq        (DQ[15:0]),      //          .dq
        .sdram_dqm       (DQM[1:0]),      //          .dqm
        .sdram_ras_n     (RAS),     		//          .ras_n
        .sdram_we_n      (WE),      		//          .we_n
        .spi_flash_MISO  (F_DI),  			//	 			spi_flash.MISO
        .spi_flash_MOSI  (F_DO),  			//          .MOSI
        .spi_flash_SCLK  (F_CLK),  			//          .SCLK
        .spi_flash_SS_n  (F_CS),  			//          .SS_n
        .spi_g_sen_MISO  (SEN_SDI),  		// 			spi_g_sen.MISO
        .spi_g_sen_MOSI  (SEN_SDO),  		//          .MOSI
        .spi_g_sen_SCLK  (SEN_SPC),  		//          .SCLK
        .spi_g_sen_SS_n  (SEN_CS),  		//          .SS_n
        .uart_rxd        (BDBUS1),        //      		uart.rxd
        .uart_txd        (BDBUS0)         //          .txd
    );	 	
	
	

	parameter tps=1000000;

	reg [40:0] 	cpt;
	reg [3:0] 	out;

	always @ (posedge CLK12M)
	begin
		cpt = cpt+1;
		if (cpt>=tps)
		begin
			cpt=0;
			out[3:0]=out[3:0]<<1;
		end
		
		if (out==0)
		begin
			out=1;
		end
		
	end

	assign LED[7:4]=out[3:0];          	
	
	
	
endmodule
